//+------------------------------------------------------------------+
//|                                                       TrioMA.mq4 |
//|                               Copyright  2011, Yury V. Reshetov |
//|                               http://heigh.ru                    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Yury V. Reshetov"
#property link      "http://heigh.ru"

//---- input parameters
extern int          ind0 = 0; 
extern int          ind1 = 0; 
extern int          ind2 = 0; 
extern int          ind3 = 0; 
extern int          ind4 = 0; 
extern int          ind5 = 0; 
extern int          ind6 = 0; 
extern int          ind7 = 0; 
extern int          p = 80; //   iMA
extern double       tp = 500; // 
extern double       sl = 500; // C
extern double       lots = 1.0; //     
extern int          mn = 888; //  
static int          prevtime = 0; //   

//   

int init() {
   prevtime = Time[0];
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {

   //      - 
   if (Time[0] == prevtime) {
      return(0);
   }
   prevtime = Time[0];
   
   //   ,    
   if(! IsTradeAllowed()) {
      Print("Trades not allowed");
      again();
      return(0);
   }

   

//     - 
   int total = OrdersTotal();   
//----
   for(int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
      // check for symbol & magic number
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == mn)) {
         return(0);
      }
   }
   
   //   
   RefreshRates();
   
   double lt = lots;

   //   
   int signal = getSignal();
   
   //     - 
   if (signal == 0) {
      return(0);
   }
   
   int ticket = -1;
   
   //          
   if (signal > 0) {
      ticket = OrderSend(Symbol(), OP_BUY, lt, Ask, 1, Bid - sl * Point, Ask + tp * Point, WindowExpertName(), mn, 0, Blue); 
      if (ticket < 0) {
         again();      
      }
   } else {
      ticket = OrderSend(Symbol(), OP_SELL, lt, Bid, 1, Ask + sl * Point, Bid - tp * Point, WindowExpertName(), mn, 0, Red); 
      if (ticket < 0) {
         again();
      }
   }
//-- Exit --
   return(0);
}

//+--------------------------- Supervisor ----------------------------------+


//  
int getSignal() {
   double       z1 = input(0); // C EMA
   double       z2 = input(1); // C LWMA
   double       z3 = input(2); // C SMMA
      
   
   double a1 = rsigmoid(z1);
   double a2 = rsigmoid(z2);
   double a3 = rsigmoid(z3);
   
   
   //           MA
   int index = a1 + a2 * 2 + a3 * 4;
   if (index == 0) {
      return(ind0);
   }
   if (index == 1) {
      return(ind1);
   }
   if (index == 2) {
      return(ind2);
   }
   if (index == 3) {
      return(ind3);
   }
   if (index == 4) {
      return(ind4);
   }
   if (index == 5) {
      return(ind5);
   }
   if (index == 6) {
      return(ind6);
   }
   return (ind7);
}

//  -     
int rsigmoid(double x) {
   if (x > 0.0) {
      return(1);
   }
   return(0);
}

//  
double input(int ind) {
   if (ind == 0) {
      return(Close[0] - iMA(Symbol(), 0, p, 0, MODE_EMA, PRICE_OPEN, 0));
   }
   if (ind == 1) {
      return(Close[0] - iMA(Symbol(), 0, p, 0, MODE_LWMA, PRICE_OPEN, 0));
   }
   return(Close[0] - iMA(Symbol(), 0, p, 0, MODE_SMMA, PRICE_OPEN, 0));
}

// 
void again() {
   prevtime = Time[1];
   Sleep(30000);
}


